#include <iostream>
using namespace std;

int n;
int64_t* fenvik;

void init_fenvik()
{
	fenvik = new int64_t[n] {};
}

int64_t sum(int r)
{
	int64_t res = 0;
	while (r >= 0)
	{
		res += fenvik[r];
		r &= (r + 1);
		r--;
	}
	return res;
}

int64_t rsq(int l, int r)
{
	return sum(r) - sum(l - 1);
}

void add(int i, int64_t num)
{
	while (i < n)
	{
		fenvik[i] += num;
		i |= i + 1;
	}
}

void set(int i, int64_t num)
{
	add(i, num - rsq(i, i));
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n; init_fenvik();
	for (int i = 0; i < n; i++)
	{
		int64_t num; cin >> num;
		add(i, num);
	}
	int q; cin >> q;
	int shift = 0;
	for (int i = 0; i < q; i++)
	{
		int cmd; cin >> cmd;
		if (cmd == 1)
		{
			int index; cin >> index;
			index = (index - 1 - shift + n) % n;
			int64_t num; cin >> num;
			set(index, num);
		}
		else
		{
			int k; cin >> k;
			shift = (shift + k) % n;
		}
		cout << sum(n - 1) << '\n';
	}
}