#include <iostream>
#include <deque>
using namespace std;

class maxqueue
{
	deque<int> q;
public:
	void add(int n)
	{
		while (!q.empty() && q.back() < n)
			q.pop_back();
		q.push_back(n);
	}
	void pop(int n)
	{
		if (q.front() == n)
			q.pop_front();
	}
	int max()
	{
		return q.front();
	}
	void clear()
	{
		q.clear();
	}
};

const int64_t mod = 1000000000;

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n; cin >> n;
	int* nums = new int[n];
	maxqueue qdown;
	int f; cin >> f;
	if (f == 1)
		for (int i = 0; i < n; i++)
		{
			int num; cin >> num; nums[i] = num;
			qdown.add(num - i);
		}
	else
	{
		int m; int64_t x, y, z;
		cin >> m >> x >> y >> z;
		int i;
		for (i = 0; i < m; i++)
		{
			int num; cin >> num; nums[i] = num;
			qdown.add(num - i);
		}
		int64_t d1 = nums[i - 2], d2 = nums[i - 1];
		for (; i < n; i++)
		{
			int64_t num = (d1 * x % mod + d2 * y % mod + z) % mod + 1; nums[i] = num;
			qdown.add(num - i);
			d1 = d2; d2 = num;
		}
	}
	int minmaxi = 0, minmax = mod + 1;
	for (int i = 0; i < n; i++)
	{
		int curmax = qdown.max() + i;
		if (curmax < minmax)
			minmax = curmax, minmaxi = i;
		int front = nums[i] - i;
		qdown.pop(front);
		qdown.add(front - n);
	}
	cout << minmax << ' ' << minmaxi + 1;
}