#include <iostream>
#include <unordered_set>
#include <cmath>
using namespace std;
const double PI = 3.141592653589793;

template <typename T>
constexpr T sqr(T a)
{
	return a * a;
}

struct tri
{
	int a2, b2, c2;
	double a, b, c, ab, bc, ca;
	tri rotated()
	{
		tri res;
		res.a = b; res.b = c; res.c = a;
		res.a2 = b2; res.b2 = c2; res.c2 = a2;
		res.ab = bc; res.bc = ca; res.ca = ab;
		return res;
	}
};
istream& operator>>(istream& in, tri& t)
{
	int x1, x2, x3, y1, y2, y3;
	in >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
	t.a2 = sqr(x1 - x2) + sqr(y1 - y2);
	t.b2 = sqr(x2 - x3) + sqr(y2 - y3);
	t.c2 = sqr(x3 - x1) + sqr(y3 - y1);
	t.a = sqrt(t.a2); t.b = sqrt(t.b2); t.c = sqrt(t.c2);
	t.bc = acos((t.b2 + t.c2 - t.a2) / (2 * t.b * t.c));
	t.ca = acos((t.a2 + t.c2 - t.b2) / (2 * t.a * t.c));
	t.ab = acos((t.a2 + t.b2 - t.c2) / (2 * t.a * t.b));
	return in;
}

bool close_to(double a, double b)
{
	return abs(a - b) <= 1e-10;
}

void sort(int& a, int& b, int& c, int& d)
{
	if (a > b) swap(a, b);
	if (b > c) swap(b, c);
	if (a > b) swap(a, b);
	if (c > d) swap(c, d);
	if (b > c) swap(b, c);
	if (a > b) swap(a, b);
}

int c(int k, int n)
{
	int res = 1;
	for (int i = n; i > k; i--)
	{
		res *= i;
		res /= n - i + 1;
	}
	return res;
}

int main()
{
	int t, n; cin >> t >> n;
	tri* tris = new tri[n * 3];
	for (int i = 0; i < n; i++)
	{
		int j = i * 3;
		cin >> tris[j];
		tris[j + 1] = tris[j].rotated();
		tris[j + 2] = tris[j + 1].rotated();
	}
	unordered_set<int> res;
	res.reserve(c(4, n));
	n *= 3;
	for (int i = 0; i < n; i++)
	{
		int reali = i / 3;
		for (int j = reali * 3 + 3; j < n; j++)
		{
			int realj = j / 3;
			double need = PI - tris[i].ab - tris[j].ab;
			for (int k = reali * 3 + 3; k < n; k++)
			{
				int realk = k / 3;
				if (realk == realj || !close_to(tris[k].ab, need))
					continue;
				int a2 = tris[i].c2, b2 = tris[j].c2, c2 = tris[k].c2;
				for (int l = 0; l < n; l++)
				{
					int reall = l / 3;
					if (reall == reali || reall == realj || reall == realk)
						continue;
					tri& tril = tris[l];
					if (tril.a2 == a2 && tril.b2 == b2 && tril.c2 == c2)
					{
						int a = reali, b = realj, c = realk, d = reall;
						sort(a, b, c, d);
						int code = a * n + b;
						code *= n; code += c;
						code *= n; code += d;
						res.insert(code);
					}
				}
			}
		}
	}
	cout << res.size() << endl;
	for (int code : res)
	{
		int d = code % n + 1;
		code /= n;
		int c = code % n + 1;
		code /= n;
		int b = code % n + 1;
		code /= n;
		cout << code + 1 << ' ' << b << ' ' << c << ' ' << d << endl;
	}
}