#include <iostream>
using namespace std;

template<class T>
constexpr T max(T a, T b)
{
	return a < b ? b : a;
}

uint64_t calc(uint64_t n, uint64_t a, uint64_t b)
{
	if (a < b) swap(a, b);
	uint64_t res = b / n;
	res = res * (res + 1) / 2 * n + res;
	res += (a - b + b % n) / n * (b + 1);
	{
		uint64_t firstmorea = a - a % n + n;
		if (firstmorea > a + b)
			return res;
		uint64_t a1 = a + b - firstmorea;
		uint64_t _n = a1 / n + 1;
		res += (a1 + a1 % n) * _n / 2 + _n;
	}
	return res;
}

void main_prog()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t; cin >> t;
	for (int i = 0; i < t; i++)
	{
		uint64_t n, a, b; cin >> n >> a >> b;
		cout << calc(n, a, b) << '\n';
	}
}

uint64_t calc_dumb(uint64_t n, uint64_t a, uint64_t b)
{
	uint64_t ab = a + b;
	uint64_t res = 0;
	for (uint64_t x = 0; x <= a; x++)
	{
		uint64_t starty = (n - x % n);
		if (starty == n)
			starty = x ? 0 : n;
		for (uint64_t y = starty; y <= b; y += n)
			res++;
	}
	return res;
}

void check()
{
	for (int n = 4; n < 100; n++)
		for (int a = 0; a <= 1000; a++)
			for (int b = 0; b <= a; b++)
			{
				uint64_t dumb = calc_dumb(n, a, b);
				if (dumb != calc(n, a, b))
				{
					cout << n << ' ' << a << ' ' << b << " (" << dumb << ")";
					return;
				}
			}
}

int main()
{
	main_prog();
}