#include <iostream>
using namespace std;

int gcd(int a, int b)
{
	if (!a)
		return b;
	return gcd(b % a, a);
}

uint64_t lcm(uint64_t a, uint64_t b)
{
	return a / gcd(a, b) * b;
}

int __cdecl intcmp(const void* a, const void* b)
{
	return *(int*)a - *(int*)b;
}

int __cdecl negintcmp(const void* a, const void* b)
{
	return *(int*)b - *(int*)a;
}

int __cdecl fraccmp(const void* a, const void* b)
{
	pair<int, int>* pa = (pair<int, int>*)a;
	pair<int, int>* pb = (pair<int, int>*)b;
	uint64_t denom = lcm(pa->second, pb->second);
	int64_t res = (int64_t)pa->first * (denom / pa->second) - (int64_t)pb->first * (denom / pb->second);
	if (res < 0)
		return -1;
	if (res > 0)
		return 1;
	return 0;
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, q; cin >> n >> q;
	pair<int, int>* fracs = new pair<int, int>[n * n];
	int n2 = n * n;
	for (int i = 0; i < n; i++)
	{
		int a; cin >> a;
		int s = i * n;
		for (int j = i * n + n - 1; j >= s; j--)
			fracs[j].first = a;
	}
	for (int i = 0; i < n; i++)
	{
		int b; cin >> b;
		for (int j = i; j < n2; j += n)
		{
			int d = gcd(fracs[j].first, b);
			fracs[j].second = b / d;
			fracs[j].first /= d;
		}
	}
	qsort(fracs, n2, sizeof(pair<int, int>), fraccmp);
	for (int i = 0; i < q; i++)
	{
		int m; cin >> m; m--;
		cout << fracs[m].first << ' ' << fracs[m].second << '\n';
	}
}