#include <iostream>
#include <set>
#include <unordered_map>
using namespace std;

template <class T>
constexpr T max(T a, T b)
{
	return a > b ? a : b;
}

int gcd(int a, int b)
{
	if (!a)
		return b;
	return gcd(b % a, a);
}

uint64_t lcm(uint64_t a, uint64_t b)
{
	return a / gcd(a, b) * b;
}

int __cdecl intcmp(const void* a, const void* b)
{
	return *(int*)a - *(int*)b;
}

int __cdecl negintcmp(const void* a, const void* b)
{
	return *(int*)b - *(int*)a;
}

int __cdecl fraccmp(const void* a, const void* b)
{
	pair<int, int>* pa = (pair<int, int>*)a;
	pair<int, int>* pb = (pair<int, int>*)b;
	uint64_t denom = lcm(pa->second, pb->second);
	int64_t res = (int64_t)pa->first * (denom / pa->second) - (int64_t)pb->first * (denom / pb->second);
	if (res < 0)
		return -1;
	if (res > 0)
		return 1;
	return 0;
}

struct fraction
{
	uint64_t num, denom;
	void init(uint64_t a, uint64_t b)
	{
		int cd = gcd(a, b);
		num = a / cd; denom = b / cd;
	}
};

bool operator<(const fraction& th, const fraction& other)
{
	uint64_t cdenom = lcm(th.denom, other.denom);
	return th.num * (cdenom / th.denom) < other.num * (cdenom / other.denom);
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, q; cin >> n >> q;
	uint64_t n2 = (uint64_t)n * n;
	int* as = new int[n], *bs = new int[n];
	for (int i = 0; i < n; i++)
		cin >> as[i];
	for (int i = 0; i < n; i++)
		cin >> bs[i];
	qsort(as, n, 4, intcmp);
	qsort(bs, n, 4, negintcmp);
	uint64_t* cs = new uint64_t[q];
	uint64_t maxc = 0;
	for (int i = 0; i < q; i++)
	{
		cin >> cs[i];
		cs[i]--;
		maxc = max(maxc, cs[i]);
	}
	int* curs = new int[n] {};
	fraction* ans = new fraction[maxc + 1];
	set<pair<fraction, int>> queue;
	for (int i = 0; i < n; i++)
	{
		pair<fraction, int> elem;
		elem.first.init(as[0], bs[i]);
		elem.second = i;
		queue.insert(elem);
	}
	for (int i = 0; i <= maxc; i++)
	{
		auto elem = queue.begin();
		ans[i] = elem->first;
		int bindex = elem->second;
		curs[bindex]++;
		queue.erase(elem);
		if (curs[bindex] == n)
			continue;
		pair<fraction, int> newelem;
		newelem.first.init(as[curs[bindex]], bs[bindex]);
		newelem.second = bindex;
		queue.insert(newelem);
	}
	for (int i = 0; i < q; i++)
		cout << ans[cs[i]].num << ' ' << ans[cs[i]].denom << '\n';
}